"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.createCustomResolver = void 0;
var strings_1 = require("../../utils/strings");
function createCustomResolver(alias) {
    var normalizedAlias = alias.map(function (_a) {
        var moduleName = _a[0], modulePaths = _a[1];
        return [strings_1.normalizeWildcardString(moduleName), modulePaths];
    });
    return function customResolver(importeeId, importerId) {
        return __awaiter(this, void 0, void 0, function () {
            var matchingAlias, resolve, moduleName, modulePaths, _a, positionals, normalizedPaths, _i, normalizedPaths_1, relativeFilePath, result;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        matchingAlias = normalizedAlias.find(function (_a) {
                            var moduleName = _a[0];
                            return new RegExp(moduleName).test(importeeId);
                        });
                        resolve = function (modulePath) {
                            return _this.resolve(modulePath, importerId, { skipSelf: true });
                        };
                        // If the imported module doesn't match any of the alias,
                        // resolve the path according to its "replacement" value.
                        if (!matchingAlias) {
                            return [2 /*return*/, resolve(importeeId).then(function (resolved) {
                                    return resolved ? resolved : { id: importeeId };
                                })];
                        }
                        moduleName = matchingAlias[0], modulePaths = matchingAlias[1];
                        _a = importeeId.match(moduleName), positionals = _a.slice(1);
                        normalizedPaths = modulePaths
                            .map(strings_1.replaceWildcardWithPositionals)
                            .map(function (modulePath) {
                            return strings_1.injectPositionals(modulePath, positionals);
                        });
                        _i = 0, normalizedPaths_1 = normalizedPaths;
                        _b.label = 1;
                    case 1:
                        if (!(_i < normalizedPaths_1.length)) return [3 /*break*/, 4];
                        relativeFilePath = normalizedPaths_1[_i];
                        return [4 /*yield*/, this.resolve(relativeFilePath)];
                    case 2:
                        result = _b.sent();
                        if (result) {
                            return [2 /*return*/, result];
                        }
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, importeeId];
                }
            });
        });
    };
}
exports.createCustomResolver = createCustomResolver;
