"use strict";
exports.__esModule = true;
exports.toTypeScript = void 0;
var compose_1 = require("../utils/compose");
var wrapPathsInArray = function (config) {
    return Object.entries(config).reduce(function (config, _a) {
        var moduleName = _a[0], modulePath = _a[1];
        config[moduleName] = [].concat(modulePath);
        return config;
    }, {});
};
/**
 * Generates partial TypeScript configuration from the given
 * path aliases.
 */
function toTypeScript(config) {
    var paths = compose_1.compose(wrapPathsInArray)(config);
    return {
        compilerOptions: {
            baseUrl: '.',
            paths: paths
        }
    };
}
exports.toTypeScript = toTypeScript;
